#ifndef CUA_HPP
#define CUA_HPP

using namespace std;

#include <vector>

template <class T>
class Cua {

public:

  //Constructoras

  /* crea una pila buida*/
  Cua(){
    elems=vector<T>(MAX_SIZE);
    ini = 0; 
    fi = -1;
    mida = 0;
  }

  /* crea una pila copia d'original*/
  Cua(const Cua& original){
    mida=original.mida;
    elems=original.elems;
    ini=original.ini;
    fi=original.fi;
//  elems=vector<T>(MAX_SIZE);
//  for (int i=0; i<mida; ++i) 
//    elems[i] = original.elems[(ini+i)%elems.size()];
//  ini=0;
//  fi=mida-1;
  }


  //Destructora
  ~Cua(){}

  //Modificadores 


  void push(const T &elemento) {
    fi=(fi+1)%elems.size();
    elems[fi]=elemento;
    ++mida;
  }
  /* afegeix l'element x a la cua */


  /* la cua no és buida */
  void pop(){
    ini=(ini+1)%elems.size();
    --mida;
  }
  /* elimina el primer element afegit a la cua */

  //Cosultores 

  /* la cua no és buida */
  T front() const {
    return elems[ini];
  }
  /* retorna el primer element afegit a la cua*/


  bool empty() const {
    return (mida==0);
  }
  /* ens retorna si la cua és buida o no */


  int size() const {
    return mida;
  }
  /* ens retorna si la mida de la cua */


private:

  static const int MAX_SIZE = 10;
  int ini; 
  int fi; 
  int mida;
  vector<T> elems;

};

#endif

